// ==UserScript==
// @name         百度广告去除
// @namespace    http://ide.yumc.pw/
// @version      0.0.6
// @description  去除百度上下推广广告
// @author       MiaoWoo
// @include      http*://*.baidu.*
// @grant        none
// @namespace    yumc
// ==/UserScript==

(function() {
  'use strict';
  var selectors = `
#content_left [style*="display:block !important;visibility:visible !important"]
[tpl="right_toplist"]
[class="c-gray c-feedback"]
[data-click*="vLevel"]
`;
  selectors = selectors.trim().split('\n');
  var count = 0;
  function showCount(cn){
    if(cn>0){
      count += cn;
      var content_right = document.querySelector('#content_right');
      if(content_right){
        content_right.style.position = 'relative';
        var style = `
line-height: 42px;
text-align: center;
background: #0c0;
color: #fff;
margin-bottom:30px;
`;
        var msgCount = document.querySelector('#msg-remove');
        if(!msgCount){
          content_right.insertAdjacentHTML('afterbegin','<div id="msg-remove" style="'+style+'"></div>');
          msgCount = document.querySelector('#msg-remove');
        }
        msgCount.innerHTML = '已过滤：'+count+'条垃圾广告，本次过滤：'+cn+'条';
      }
    }
  }
  function clear() {
    tempCount = 0
    selectors.forEach(function(selector) {
      var doms = document.querySelectorAll(selector);
      if(doms.length){
        doms = Array.from(doms);
        tempCount += doms.length;
        doms.forEach(function(dom) {
          dom.parentNode.removeChild(dom);
        });
      }
    });
    var adKeyword = ['广告', '评价']
    var classKeyWord = ['.m', 'a span']
    classKeyWord.forEach(function (c) {
      var result = $(c)
      result.each(function (index,element) {
        if(adKeyword.indexOf($(element).text())){
          $(element).parent().parent().remove();
          tempCount++
        }
      });
    })
    $('.ad-block').each(function (index,element) {
      $(element).parent().parent().parent().remove();
      tempCount++
    })
    $('div a').each(function (index, element) {
      if($(element).text()=="广告"){
        $(element).parent().parent().parent().parent().parent().parent().parent().remove()
      }
      tempCount++
    })
    showCount(tempCount);
  }
  setInterval(clear, 500);
})();